var nomi_checkbox = ["lastfmcode-enable-bbcode"];
var preferenze;
var localizedStrings;

if (!preferenze) {
	preferenze = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefService);
	}

var lastfmcode = {
	init: function()
	{
		var menu = document.getElementById('contentAreaContextMenu');
		menu.addEventListener('popupshowing', lastfmcode.showHide, false);

		//Per evitare di recuperarle pi volte, il bundle con le stringhe localizzate viene memorizzato nella variabile globale localizedStrings
		localizedStrings = document.getElementById("lastfmcode-localizedStrings");
	},


	showHide: function() {
		var enableBBCodeMenu;

		//Leggo i valori effettivi delle preferenze
		enableBBCodeMenu = preferenze.GetBoolPref("lastfmcode.bbcodemenu");

		if(enableBBCodeMenu){
			document.getElementById('context-lastfmcode-bbcode').hidden = document.getElementById('context-undo').hidden;
		}else{
			document.getElementById('context-lastfmcode-bbcode').hidden = true;
		}

	},


	disableMenu: function (idPref) {
		//Scrivo false nella preferenza
		preferenze.SetBoolPref(idPref,false);
	},


	promptWindow: function (stringa){
		//Questa funzione serve a risolvere il bug relativo alla funzione prompt
		//https://bugzilla.mozilla.org/show_bug.cgi?id=282341

		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
				    .getService(Components.interfaces.nsIPromptService);
		var result = {value:null};
		promptService.prompt(null, "lastfmcode", stringa, result, null, {value:0});
		return result.value;
	},


	showPreferences: function() {
		window.openDialog('chrome://lastfmcode/content/lastfmcodePrefs.xul', '_blank', 'chrome,dialog,modal,centerscreen');
	},


	showColorPick: function() {
		var colore;
		window.openDialog('chrome://lastfmcode/content/lastfmcodePickColor.xul', '_blank', 'chrome,dialog,modal,centerscreen');
		if (preferenze.GetBoolPref("lastfmcode.bbcodeconferma")) {
					//Entro in questo ciclo solo se  stato premuto OK
					colore=preferenze.GetCharPref("lastfmcode.bbcodecolore");
					lastfmcode.lastfmcode('color', colore);
				    }
	},


	memorizzaColore: function(){
		//Salvo in una preferenza il valore scelto dall'utente
		preferenze.SetCharPref("lastfmcode.bbcodecolore", document.getElementById('lastfmcodeSelectedColor').color);
		preferenze.SetDefaultBoolPref("lastfmcode.bbcodeconferma", true);
		return true;
	},


	annullaCambiaColore: function(){
		//Annullo il cambiamento di colore
		preferenze.SetDefaultBoolPref("lastfmcode.bbcodeconferma", false);
	},


	caricaColore: function(){
		//imposto il colore sull'ultimo colore selezionato
		document.getElementById('lastfmcodeSelectedColor').color=preferenze.GetCharPref("lastfmcode.bbcodecolore");
		document.getElementById('coloreSelezionato').style.backgroundColor=preferenze.GetCharPref("lastfmcode.bbcodecolore");
	},


	lastfmcode: function(myCommand,extraParam) {

		var theBox = document.commandDispatcher.focusedElement;
		var oPosition = theBox.scrollTop;
		var oHeight = theBox.scrollHeight;

		lastfmcode.insertAtCursorSetup(myCommand, extraParam);
		var nHeight = theBox.scrollHeight - oHeight;
		theBox.scrollTop = oPosition + nHeight;
	},


	trim: function(myString) {
		return myString.replace(/^\s*|\s*$/g,"");
	},


	getClipboardContent: function() {
		//http://www.expressnewsindia.com/site/jabalpur/8_4%20-%20Using%20the%20Clipboard.htm
		var widgetAppunti = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
		if (!widgetAppunti){
			return false;
		}

		var widgetTransferable = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
		if (!widgetTransferable){
			return false;
		}

		widgetTransferable.addDataFlavor("text/unicode");
		try {
			widgetAppunti.getData(widgetTransferable,widgetAppunti.kGlobalClipboard);
		} catch(e) {
		}

		//At this point widgetTransferable contains il contenuto degli appunti

		var str_clipboard = new Object();
		var strLength = new Object();
		try {
			widgetTransferable.getTransferData("text/unicode",str_clipboard,strLength);
			if (str_clipboard)
			{
				str_clipboard=str_clipboard.value.QueryInterface(Components.interfaces.nsISupportsString).data;
			}
			return lastfmcode.trim(str_clipboard);
		} catch (e) {
			alert(localizedStrings.getString("lastfmcode.nothingInClipboard"));
			return "";
		}
	},


	getSelectedText: function() {
		//Gets selected text, and trims the selection if begins or ends with spaces
		var str = null;
		var theBox = document.commandDispatcher.focusedElement;
		var startPos = theBox.selectionStart;
		var endPos = theBox.selectionEnd;

		//trim spaces
		try {
			while (theBox.value.substring(startPos,startPos+1)==" " && startPos<endPos) {
				startPos = startPos + 1;
			}
			while (theBox.value.substring(endPos,endPos-1)==" " && startPos<endPos) {
				endPos = endPos - 1;
			}

			//if selected text is spaces only, then we revert to the orginal positions, considering the user knwow what he's doing
			if (startPos == endPos) {
				startPos = theBox.selectionStart;
				endPos = theBox.selectionEnd;
			} else {
				theBox.selectionStart = startPos;
				theBox.selectionEnd = endPos;
			}

			str = theBox.value.substring(startPos, endPos);
			return str;
		} catch (e) {
			var txt="There was an error.\n\n";
			txt+="Error description: " + err.description + "\n\n";
			txt+="Please tell the extension author about this.\n\n";
			txt+="Click OK to continue.\n\n";
			alert(txt);
		}
	},



	insertAtCursorSetup: function(myCommand, extraParam) {
		// Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
		// Modified to return cursor to correct place
		//extraParam al momento  usato solo dalla funzione per il colore

		//variabili per la composizione del wizard-url
		var indcomposto = null;
		var nomecomposto = null;
		//variabili per il quote
		var autore = null;
		var stringa = null;

		//variabili per la localizzazione delle stringhe javascript
		var strInsAuthor = localizedStrings.getString("lastfmcode.INS_AUTHOR");
		var strInsLinkName = localizedStrings.getString("lastfmcode.INS_LINKNAME");
		var strInsArtistName = localizedStrings.getString("lastfmcode.INS_ARTISTNAME");
		var strInsFontSize = localizedStrings.getString("lastfmcode.INS_FONTSIZE");
		var strInsFontColor = localizedStrings.getString("lastfmcode.INS_FONTCOLOR");
		var strUrlCompostoStep1 = localizedStrings.getString("lastfmcode.URLCOMPOSTO_STEP1");
		var strUrlCompostoStep2 = localizedStrings.getString("lastfmcode.URLCOMPOSTO_STEP2");
		var strAlbumCompostoStep1 = localizedStrings.getString("lastfmcode.ALBUMCOMPOSTO_STEP1");
		var strAlbumCompostoStep2 = localizedStrings.getString("lastfmcode.ALBUMCOMPOSTO_STEP2");
		var strTrackCompostoStep1 = localizedStrings.getString("lastfmcode.TRACKCOMPOSTO_STEP1");
		var strTrackCompostoStep2 = localizedStrings.getString("lastfmcode.TRACKCOMPOSTO_STEP2");
		var strEnterFontName = localizedStrings.getString("lastfmcode.EnterFontName");

		switch (myCommand){
		case "quoteclip":
			autore = lastfmcode.promptWindow(strInsAuthor);
			if (autore!=null) {
				if (autore=="") {
					lastfmcode.insertAtCursor("[quote]" + lastfmcode.getClipboardContent() + "[/quote]");
				} else {
					lastfmcode.insertAtCursor("[quote][b]Quoth [user]"+ autore +"[/user][/b]:\n" + lastfmcode.getClipboardContent() + "[/quote]");
				}
		}
		break;

		case "quote":
			autore = lastfmcode.promptWindow(strInsAuthor);
			if (autore!=null) {
				if (autore=="") {
					lastfmcode.insertAtCursor("[quote]" + lastfmcode.getSelectedText() + "[/quote]");
				} else {
					lastfmcode.insertAtCursor("[quote][b]Quoth [user]"+ autore +"[/user][/b]:\n" + lastfmcode.getSelectedText() + "[/quote]");
				}
			}
		break;

		case "img":
			lastfmcode.insertAtCursor("[img]" + lastfmcode.getSelectedText() + "[/img]");
		break;

		case "imgclip":
			lastfmcode.insertAtCursor("[img]" + lastfmcode.getClipboardContent() + "[/img]");
		break;

		case "codeclip":
			lastfmcode.insertAtCursor("[code]" + lastfmcode.getClipboardContent() + "[/code]");
		break;

		case "urltag":
			lastfmcode.insertAtCursor("[url]" + lastfmcode.getSelectedText() + "[/url]");
		break;

		case "tagtag":
			lastfmcode.insertAtCursor("[tag]" + lastfmcode.getSelectedText() + "[/tag]");
		break;

		case "artisttag":
			lastfmcode.insertAtCursor("[artist]" + lastfmcode.getSelectedText() + "[/artist]");
		break;

		case "labeltag":
			lastfmcode.insertAtCursor("[label]" + lastfmcode.getSelectedText() + "[/label]");
		break;

		case "usertag":
			lastfmcode.insertAtCursor("[user]" + lastfmcode.getSelectedText() + "[/user]");
		break;

		case "grouptag":
			lastfmcode.insertAtCursor("[group]" + lastfmcode.getSelectedText() + "[/group]");
		break;

		case "placetag":
			lastfmcode.insertAtCursor("[place]" + lastfmcode.getSelectedText() + "[/place]");
		break;

		case "youtubetag":
			lastfmcode.insertAtCursor("[youtube]" + lastfmcode.getSelectedText() + "[/youtube]");
		break;

		case "googlevideotag":
			lastfmcode.insertAtCursor("[googlevideo]" + lastfmcode.getSelectedText() + "[/googlevideo]");
		break;

		case "urltagname":
			stringa = null;
			stringa = lastfmcode.promptWindow(strInsLinkName);
			if (stringa!=null) {    lastfmcode.insertAtCursor("[url=" + lastfmcode.getSelectedText() + "]" + stringa + "[/url]"); }
		break;

		case "albumtagname":
			stringa = null;
			stringa = lastfmcode.promptWindow(strInsArtistName);
			if (stringa!=null) {    lastfmcode.insertAtCursor("[album artist=" + stringa + "]" + lastfmcode.getSelectedText() + "[/album]"); }
		break;

		case "tracktagname":
			stringa = null;
			stringa = lastfmcode.promptWindow(strInsArtistName);
			if (stringa!=null) {    lastfmcode.insertAtCursor("[track artist=" + stringa + "]" + lastfmcode.getSelectedText() + "[/track]"); }
		break;

		case "url":
			lastfmcode.insertAtCursor("[url]" + lastfmcode.getClipboardContent() + "[/url]");
		break;

		case "youtube":
			lastfmcode.insertAtCursor("[youtube]" + lastfmcode.getClipboardContent() + "[/youtube]");
		break;

		case "googlevideo":
			lastfmcode.insertAtCursor("[googlevideo]" + lastfmcode.getClipboardContent() + "[/googlevideo]");
		break;

		case "tag":
			lastfmcode.insertAtCursor("[tag]" + lastfmcode.getClipboardContent() + "[/tag]");
		break;

		case "artist":
			lastfmcode.insertAtCursor("[artist]" + lastfmcode.getClipboardContent() + "[/artist]");
		break;

		case "user":
			lastfmcode.insertAtCursor("[user]" + lastfmcode.getClipboardContent() + "[/user]");
		break;

		case "urlclip":
			stringa = null;
			stringa = lastfmcode.promptWindow(strInsLinkName);
			if (stringa!=null) { lastfmcode.insertAtCursor("[url=" + lastfmcode.getClipboardContent() + "]" + stringa + "[/url]"); }
		break;

		case "albumclip":
			stringa = null;
			stringa = lastfmcode.promptWindow(strInsArtistName);
			if (stringa!=null) { lastfmcode.insertAtCursor("[album artist=" + stringa + "]" + lastfmcode.getClipboardContent() + "[/album]"); }
		break;

		case "trackclip":
			stringa = null;
			stringa = lastfmcode.promptWindow(strInsArtistName);
			if (stringa!=null) { lastfmcode.insertAtCursor("[track artist=" + stringa + "]" + lastfmcode.getClipboardContent() + "[/track]"); }
		break;

		case "urlselection":
			lastfmcode.insertAtCursor("[url=" + lastfmcode.getClipboardContent() + "]" + lastfmcode.getSelectedText() + "[/url]");
		break;

		case "eventselection":
			var eventselectionURL=lastfmcode.getClipboardContent();
			//if a number, assume the number is an existing event number and make an url of it
			if (!isNaN(eventselectionURL)) {eventselectionURL="http://www.last.fm/event/"+eventselectionURL;}
			lastfmcode.insertAtCursor("[event=" + eventselectionURL + "]" + lastfmcode.getSelectedText() + "[/event]");
		break;

		case "albumselection":
			lastfmcode.insertAtCursor("[album artist=" + lastfmcode.getClipboardContent() + "]" + lastfmcode.getSelectedText() + "[/album]");
		break;

		case "trackselection":
			lastfmcode.insertAtCursor("[track artist=" + lastfmcode.getClipboardContent() + "]" + lastfmcode.getSelectedText() + "[/track]");
		break;

		case "urlcomposto":
			nomecomposto = lastfmcode.promptWindow(strUrlCompostoStep1);
			if (nomecomposto!=null) {
				indcomposto = lastfmcode.promptWindow(strUrlCompostoStep2);
				if (indcomposto!=null) { lastfmcode.insertAtCursor("[url=" + indcomposto + "]" + nomecomposto + "[/url]");}
			}
		break;

		case "albumcomposto":
			nomecomposto = lastfmcode.promptWindow(strAlbumCompostoStep1);
			if (nomecomposto!=null) {
				indcomposto = lastfmcode.promptWindow(strAlbumCompostoStep2);
				if (indcomposto!=null) { lastfmcode.insertAtCursor("[album artist=" + nomecomposto + "]" + indcomposto + "[/album]");}
			}
		break;

		case "trackcomposto":
			nomecomposto = lastfmcode.promptWindow(strTrackCompostoStep1);
			if (nomecomposto!=null) {
				indcomposto = lastfmcode.promptWindow(strTrackCompostoStep2);
				if (indcomposto!=null) { lastfmcode.insertAtCursor("[track artist=" + nomecomposto + "]" + indcomposto + "[/track]");}
			}
		break;

		case "bold":
			lastfmcode.insertAtCursor("[b]" + lastfmcode.getSelectedText() + "[/b]");
		break;

		case "lista":
			lastfmcode.insertAtCursor("[list]\n[*]" + lastfmcode.replace_CR(lastfmcode.getSelectedText(),"[*]*") + "\n[/list]");
		break;

		case "listanum":
			lastfmcode.insertAtCursor("[list=1]\n[*]" + lastfmcode.replace_CR(lastfmcode.getSelectedText(),"[*]*") + "\n[/list]");
		break;

		case "listaalf":
			lastfmcode.insertAtCursor("[list=a]\n[*]" + lastfmcode.replace_CR(lastfmcode.getSelectedText(),"[*]*") + "\n[/list]");
		break;

		case "listaclip":
			lastfmcode.insertAtCursor("[list]\n[*]" + lastfmcode.replace_CR(lastfmcode.getClipboardContent(),"[*]*") + "\n[/list]");
		break;

		case "listaclipnum":
			lastfmcode.insertAtCursor("[list=1]\n[*]" + lastfmcode.replace_CR(lastfmcode.getClipboardContent(),"[*]*") + "\n[/list]");
		break;

		case "listaclipalf":
			lastfmcode.insertAtCursor("[list=a]\n[*]" + lastfmcode.replace_CR(lastfmcode.getClipboardContent(),"[*]*") + "\n[/list]");
		break;

		case "italic":
			lastfmcode.insertAtCursor("[i]" + lastfmcode.getSelectedText() + "[/i]");
		break;

		case "underline":
			lastfmcode.insertAtCursor("[u]" + lastfmcode.getSelectedText() + "[/u]");
		break;

		case "strike":
			lastfmcode.insertAtCursor("[s]" + lastfmcode.getSelectedText() + "[/s]");
		break;

		case "superscript":
			lastfmcode.insertAtCursor("[sup]" + lastfmcode.getSelectedText() + "[/sup]");
		break;

		case "subscript":
			lastfmcode.insertAtCursor("[sub]" + lastfmcode.getSelectedText() + "[/sub]");
		break;

		case "code":
			lastfmcode.insertAtCursor("[code]" + lastfmcode.getSelectedText() + "[/code]");
		break;

		case "size":
			stringa = null;
			stringa = lastfmcode.promptWindow(strInsFontSize);
			if (stringa!=null) { lastfmcode.insertAtCursor("[size=" + stringa + "]" + lastfmcode.getSelectedText() + "[/size]"); }
		break;

		case "fontname":
			stringa = null;
			stringa = lastfmcode.promptWindow(strEnterFontName);
			if (stringa!=null) { lastfmcode.insertAtCursor("[font=" + stringa + "]" + lastfmcode.getSelectedText() + "[/font]"); }
		break;

		case "alignright":
			lastfmcode.insertAtCursor("[align=right]" + lastfmcode.getSelectedText() + "[/align]");
		break;

		case "alignleft":
			lastfmcode.insertAtCursor("[align=left]" + lastfmcode.getSelectedText() + "[/align]");
		break;

		case "aligncenter":
			lastfmcode.insertAtCursor("[align=center]" + lastfmcode.getSelectedText() + "[/align]");
		break;

		case "alignjustify":
			lastfmcode.insertAtCursor("[align=justify]" + lastfmcode.getSelectedText() + "[/align]");
		break;

		case "color":
			lastfmcode.insertAtCursor("[color=" + extraParam + "]" + lastfmcode.getSelectedText() + "[/color]");
		break;

		default : alert(localizedStrings.getString("lastfmcode.noOptionSelected"));
		}//end switch
	},


	insertAtCursor: function(aText) {
	//Codice originale: http://kb.mozillazine.org/index.phtml?title=Dev_:_Tips_:_Inserting_text_at_cursor
		try {
			var command = "cmd_insertText";
			var controller = document.commandDispatcher.getControllerForCommand(command);
			if (controller && controller.isCommandEnabled(command)) {
				controller = controller.QueryInterface(Components.interfaces.nsICommandController);
				var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
				params = params.createInstance(Components.interfaces.nsICommandParams);
				params.setStringValue("state_data", aText);
				controller.doCommandWithParams(command, params);
			}
		}catch (e) {
			var txt="There was an error.\n\n";
			txt+="Error description: " + err.description + "\n\n";
			txt+="Please tell the extension author about this.\n\n";
			txt+="Click OK to continue.\n\n";
			alert(txt);
		}
	},


	replace_CR: function(myText,replaceWith){
		//Ultima modifica flod 08112004
		//Riferimento codice per la gestione dei caratteri di fine riga: http://www.jennifermadden.com/162/examples/stringEscape.html

		var OS;
		//Prima di iniziare elimino gli spazi vuoti all'inizio della stringa
		while ( myText.length > 0 ){
			if (myText.charAt(0) == "\n") {
					myText=myText.substr(1,myText.length);
				}
			else { break; }
		}

		myText = escape(myText);
		for(i=0; i<myText.length; i++){
			if(myText.indexOf("%0D%0A") > -1){
				//Windows encodes returns as \r\n hex
				myText=myText.replace("%0D%0A",replaceWith);
				OS="win";
				}
				else if(myText.indexOf("%0A") > -1){
						//Unix encodes returns as \n hex
						myText = myText.replace("%0A",replaceWith);
						OS="unix";
						}
						else if(myText.indexOf("%0D") > -1){
							//Machintosh encodes returns as \r hex
							myText = myText.replace("%0D",replaceWith);
							OS="mac";
							}
		}

		//Questa parte non riguarda la funzionalit dell'estensione, serve solamente a rendere pi leggibile il BBcode prodotto
		//In base al sistema operativo aggiungo un ritorno prima del codice "[*]*", sostituendolo con "acapo[*]"
		for(i=0; i<myText.length; i++){
			if(OS=="win"){
				myText=myText.replace("[*]*","%0D%0A[*]");
				}
				else if(OS=="unix"){
					myText=myText.replace("[*]*","%0A[*]");
					}
					else if(OS=="mac"){
						myText=myText.replace("[*]*","%0D[*]");
						}
		}

		myText = unescape(myText);
		//Quando opero su una stringa presa dagli appunti, all'inizio si trova un "\n[*]" di troppo da eliminare
		while ( myText.length > 0 ){
			if (myText.substr(0,4) == "\n[*]") {
					myText=myText.substr(4,myText.length);
				}
			else { break; }
		}

		//Se la fine della stringa  [*] posso eliminare questi 3 caratteri, visto che significa che sono state selezionate
		//righe vuote nell'elenco; ripeto fino a quando la stringhe finisce con caratteri diversi da [*]
		while ( myText.length > 0 ){
			if (myText.substr(myText.length-3,myText.length+1) == "[*]") {
					myText=myText.substr(0,myText.length-4);
				}
			else { break; }
		}

		//Parto dall'inizio ed elimino eventuali [*]\n (elementi di lista vuoti); in questo modo elimino tutti gli spazi vuoti all'interno della lista
		while ( myText.length > 0 ){
			if (myText.indexOf("[*]\n") == -1) {
			    break; //nessun elemento vuoto
			  }  else {
				    //Copio la stringa tranne il pezzo "[*]\n"
				    myText = myText.substr(0,myText.indexOf("[*]\n")) + myText.substr(myText.indexOf("[*]\n")+4,myText.length);
				  }
		}
		return myText;
	},


	htmlreplace_CR: function(myText,replaceWith){
		//Ultima modifica Flod 08112004
		//Riferimento codice per la gestione dei caratteri di fine riga: http://www.jennifermadden.com/162/examples/stringEscape.html

		var OS;
		//Prima di iniziare elimino gli spazi vuoti all'inizio della stringa
		while ( myText.length > 0 ){
			if (myText.charAt(0) == "\n") {
					myText=myText.substr(1,myText.length);
				}
			else { break; }
		}

		myText = escape(myText);

		for(i=0; i<myText.length; i++){
			if(myText.indexOf("%0D%0A") > -1){
				//Windows encodes returns as \r\n hex
				myText=myText.replace("%0D%0A",replaceWith);
				OS="win";
				}
				else if(myText.indexOf("%0A") > -1){
						//Unix encodes returns as \n hex
						myText = myText.replace("%0A",replaceWith);
						OS="unix";
						}
						else if(myText.indexOf("%0D") > -1){
							//Machintosh encodes returns as \r hex
							myText = myText.replace("%0D",replaceWith);
							OS="mac";
							}
		}

		//Questa parte non riguarda la funzionalit dell'estensione, serve solamente a rendere pi leggibile il BBcode prodotto
		//In base al sistema operativo aggiungo un ritorno prima del codice "[*]*", sostituendolo con "acapo[*]"
		for(i=0; i<myText.length; i++){
			if(OS=="win"){
				myText=myText.replace("[*]*","</li>%0D%0A<li>");
				}
				else if(OS=="unix"){
					myText=myText.replace("[*]*","</li>%0A<li>");
					}
					else if(OS=="mac"){
						myText=myText.replace("[*]*","</li>%0D<li>");
						}
		}

		myText = unescape(myText);

		//Quando opero su una stringa presa dagli appunti, all'inizio si trova un "</li>\n<li>" di troppo da eliminare

		while ( myText.length > 0 ){
			if (myText.substr(0,10) == "</li>\n<li>") {
					myText=myText.substr(10,myText.length);
				}
			else { break; }
		}

		//Se la fine della stringa  "<li>" posso eliminare questi caratteri ed il "\n</li>" (in tutto 10) che li precederono
		//( stata selezionata una riga vuota)
		while ( myText.length > 0 ){
			if (myText.substr(myText.length-4,myText.length+1) == "<li>") {
					myText=myText.substr(0,myText.length-10);
				}
			else { break; }
		}

		//Parto dall'inizio ed elimino eventuali <li></li>\n (elementi di lista vuoti); in questo modo elimino tutti gli spazi vuoti all'interno della lista
		while ( myText.length > 0 ){
			if (myText.indexOf("<li></li>\n") == -1) {
			    break; //nessun elemento vuoto
			  }  else {
				    //Copio la stringa tranne il pezzo "[*]\n"
				    myText = myText.substr(0,myText.indexOf("<li></li>\n")) + myText.substr(myText.indexOf("<li></li>\n")+10,myText.length);
				  }
		}

		return myText;
	},


	//Carico tutte le preferenze con un ciclo; questa funzione viene chiamata sull'onload della finestra lastfmcodePrefs.xul
	caricaPreferenze: function()
	{
		var i;
		try {
			for (i=0; i<nomi_checkbox.length;++i) {
				var preferenza = document.getElementById(nomi_checkbox[i]);
				preferenza.checked = preferenze.GetBoolPref(preferenza.getAttribute("prefstring"));
			}
		} catch(e) {
			var messaggio;
			messaggio = localizedStrings.getString("lastfmcode.ERR_LOAD_PREFS") + e + "*)";
			alert(messaggio);
		};
	},


	//Salvataggio preferenze
	salvaPreferenze: function()
	{
		var i;
		try {
			for (i=0; i<nomi_checkbox.length;++i) {
				var preferenza = document.getElementById(nomi_checkbox[i]);
				preferenze.SetBoolPref(preferenza.getAttribute("prefstring"),preferenza.checked);
			}
		} catch(e) {
			var messaggio;
			messaggio = localizedStrings.getString("lastfmcode.ERR_SAVE_PREFS") + e + "*)";
			alert(messaggio);
		};
	},


}

window.addEventListener('load', lastfmcode.init, false);